program apagarpc;
{$APPTYPE CONSOLE}

uses
  SysUtils, Windows, shellapi;

// AjpdSoft ApagarPC
// (c) 2003 AjpdSoft
// http://www.ajpdsoft.com/

var
  logoff : Boolean = False;
  reboot : Boolean = False;
  warn : Boolean = False;
  downQuick : Boolean = False;
  cancelShutdown : Boolean = False;
  powerOff : Boolean = False;
  timeDelay : Integer = 0;
  hibernation : boolean = False;

function HasParam(Opt: Char): Boolean;
var
  x : Integer;
begin
  Result := False;
  for x := 1 to ParamCount do
    if (ParamStr(x) = '-' + opt) or (ParamStr(x) = '/' + opt) then
      Result := True;
end;

function GetErrorstring: string;
var
  lz : Cardinal;
  err : array[0..512] of Char;
begin
  lz := GetLastError;
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, lz, 0, @err, 512, nil);
  Result := string(err);
end;

procedure DoShutdown;
var
  rl, flgs : Cardinal;
  hToken : Cardinal;
  tkp : TOKEN_PRIVILEGES;
begin
  flgs := 0;
  if hibernation = True then
    ShellExecute( 0, 'open', 'rundll32.exe', PChar
        ('Powrprof.dll, SetSuspendState' ), nil, SW_SHOWNORMAL)
  else
  begin
    if downQuick then
      flgs := flgs or EWX_FORCE;
    if not reboot then
      flgs := flgs or EWX_SHUTDOWN;
    if reboot then
      flgs := flgs or EWX_REBOOT;
    if poweroff and (not reboot) then
      flgs := flgs or EWX_POWEROFF;
    if logoff then
      flgs := (flgs and (not (EWX_REBOOT or EWX_SHUTDOWN or EWX_POWEROFF))) or EWX_LOGOFF;
    if Win32Platform = VER_PLATFORM_WIN32_NT then
    begin
      if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES
               or TOKEN_QUERY, hToken) then
        Writeln('No se ha podido abrir el proceso. [' + GetErrorstring + ']')
      else
      begin
        if LookupPrivilegeValue(nil, 'SeShutdownPrivilege', tkp.Privileges[0].Luid) then
        begin
          tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
          tkp.PrivilegeCount           := 1;
          AdjustTokenPrivileges(hToken, False, tkp, 0, nil, rl);
          if GetLastError <> ERROR_SUCCESS then
            Writeln('Se ha producido un error al intentar ajustar los privilegios.');
        end
        else
          Writeln('No se ha encontrado el valor del privilegio. [' + GetErrorstring + ']');
      end;
    {if CancelShutdown then
       if AbortSystemShutdown(nil) = False then
         Writeln(\'Cannot abort. [\' + GetErrorstring + \']\')
       else
         Writeln(\'Cancelled.\')
       else
       begin
         if InitiateSystemShutdown(nil, nil, timeDelay, downQuick, Reboot) = False then
           Writeln(\'Cannot go down. [\' + GetErrorstring + \']\')
         else
           Writeln(\'Shutting down!\');
         end;
    }
    end;
    //     else begin
    ExitWindowsEx(flgs, 0);
    //     end;
  end;
end;

begin
  Writeln('AjpdSoft ApagarPC v1.0');
  Writeln('2003 AjpdSoft. Todos los derechos reservados.');
  Writeln('http://www.ajpdsoft.com');
  Writeln('');
  if HasParam('?') or (ParamCount = 0) then
  begin
    Writeln('Uso del comando: apagarpc [-brplnkhc]');
    Writeln('        -b:      hiberna el equipo (si lo admite).');
    Writeln('        -r:      reinicia el equipo.');
    Writeln('        -p:      apaga equipo totalmente. Si tiene aplicaciones');
    Writeln('                 abiertas, necesitara el parametro -n para que');
    Writeln('                 cierre todas las aplicaciones abiertas.');
    Writeln('        -l:      cierra la sesion del usuario actual.');
    Writeln('        -n:      cierra todas las aplicaciones abiertas antes');
    Writeln('                 de apagar.');
    Writeln('        -k:      no apaga totalmente, cierra el equipo y lo');
    Writeln('                 prepara para el apagado.');
    Writeln('        -h:      prepara el equipo para apagado.');
    Writeln('        -c:      cancela el cierre.');
    Writeln('');
    Writeln('Ejemplo:');
    Writeln('  Para apagar el equipo (cerrando las aplicaciones abiertas):');
    Writeln('    apagarpc -p -n');
  end
  else
  begin
    if HasParam('k') then warn := True;
    if HasParam('r') then reboot := True;
    if HasParam('h') and reboot then
    begin
      Writeln('Error: no ha especificado los parmetros -r y -h juntos.');
      Exit;
    end;
    if HasParam('h') then reboot := False;
    if HasParam('n') then downQuick := True;
    if HasParam('c') then cancelShutdown := True;
    if HasParam('p') then powerOff := True;
    if HasParam('l') then logoff := True;
    if HasParam('b') then hibernation := True;
    DoShutdown;
  end;
end.
